<template>
  <section diff-row :type="diffRow.type">
    <template v-if="diffRow.type === 'clob'">
      <DiffClob flex :diffRow="diffRow" />
    </template>
    <template v-else>
      <DiffSide :diffRow="diffRow" perspective="old" />
      <md-icon md-src="/img/md/keyboard_arrow_right.svg" />
      <DiffSide :diffRow="diffRow" perspective="new" />
      <template v-if="canFollow">
        <md-button v-if="diffRow.type === 'foreign-key'" class="md-icon-button md-raised md-accent" @click="$emit('follow', diffRow)">
          <md-icon md-src="/img/md/keyboard_arrow_right.svg" />
        </md-button>
        <p v-else empty-box></p>
      </template>

    </template>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch, Prop } from 'vue-property-decorator';
import DiffSide from './diffSide.vue';
import DiffClob from './diffClob.vue';
import { DiffRow } from '../../lib/diffData';

@Component({
  components: {
    DiffSide,
    DiffClob,
  },
})
export default class extends Vue {
  @Prop()
  private diffRow!: DiffRow;

  @Prop({default: false})
  private canFollow!: boolean;
}
</script>

<style lang="scss" scoped>
$label-height: 12px;

[diff-row] {
  display: flex;
  flex-direction: row;
  align-items: flex-start;
  margin-bottom: 1.5em;

  > .md-icon {
    margin: 0;
    margin-top: $label-height;
  }

  [empty-box] {
    width: 40px;
  }

  [flex] {
    flex: 1;
  }
}
</style>
